// Copyright (c) 2005-2006 Regis COSNIER, All Rights Reserved.
// This program is free software and may be distributed
// according to the terms of the GNU General Public License (GPL) version 2 or later.

function Mob(editorPlaceElement, initHtml, mobPath)
{
	this.isIE = (window.ActiveXObject ? true : false);
	this.isMozilla = (window.sidebar ? true : false);
	this.editorPlace = editorPlaceElement;
	this.editorElement = null;
	this.basePath = (mobPath ? mobPath : "");
	this.designedModeReadyCallback = null;
	this.beginNewEditionCallback = null;

	if(this.isIE || this.isMozilla)
	{
		this.modeHTML = false;
		this.editorReady = false;
	
		var body = document.getElementsByTagName('body')[0];
	
		var tableEditor = document.createElement("table");
		tableEditor.style.width = "100%";
		tableEditor.style.height = "100%";
		var tableBody = document.createElement("tbody");
	
		var tableToolbarRow = document.createElement("tr");
		var tableToolbarCell = document.createElement("td");
		tableToolbarCell.style.backgroundColor = "#f0e4c1"; //"#DEDEDE";
		tableToolbarCell.style.width = "100%";
	
		// Create the toolbar
		{
			var input = document.createElement("input");
			input.setAttribute("type", "checkbox");
			input.mob = this;
			input.onclick = function() { this.mob.viewSource(this.checked); };
			tableToolbarCell.appendChild(input);
			tableToolbarCell.appendChild(document.createTextNode("View HTML "));
	
	
			this.toolbar = document.createElement("span");
	
			var selectFormatBlock = document.createElement("select");
			selectFormatBlock.mob = this;
			selectFormatBlock.onchange = function() { this.mob.editorExec('formatblock', this); };
			var formatblock = new Array(
				{ value: "<p>", text: "Normal" },
				{ value: "<p>", text: "Paragraph" },
				{ value: "<h1>", text: "Heading 1 &lt;H1&gt;" },
				{ value: "<h2>", text: "Heading 2 &lt;H2&gt;" },
				{ value: "<h3>", text: "Heading 3 &lt;H3&gt;" },
				{ value: "<h4>", text: "Heading 4 &lt;H4&gt;" },
				{ value: "<h5>", text: "Heading 5 &lt;H5&gt;" },
				{ value: "<h6>", text: "Heading 6 &lt;H6&gt;" },
				{ value: "<address>", text: "Address &lt;ADDR&gt;" },
				{ value: "<pre>", text: "Formatted &lt;PRE&gt;" }
			);
			for(var i = 0; i < formatblock.length; i++)
			{
				var input = document.createElement("option");
				input.setAttribute("value", formatblock[i].value);
				input.innerHTML = formatblock[i].text;
				selectFormatBlock.appendChild(input);
			}
			this.toolbar.appendChild(selectFormatBlock);
			this.toolbar.appendChild(document.createTextNode(" "));
			
			var selectFontName = document.createElement("select");
			selectFontName.mob = this;
			selectFontName.onchange = function() { this.mob.editorExec('fontname', this); };
			var fontName = new Array(
				{ value: "Font", text: "Font" },
				{ value: "Arial", text: "Arial" },
				{ value: "Courier New", text: "Courier" },
				{ value: "Times New Roman", text: "Times" }
			);
			for(var i = 0; i < fontName.length; i++)
			{
				var input = document.createElement("option");
				input.setAttribute("value", fontName[i].value);
				input.innerHTML = fontName[i].text;
				selectFontName.appendChild(input);
			}
			this.toolbar.appendChild(selectFontName);
			this.toolbar.appendChild(document.createTextNode(" "));
	
			var selectFontSize = document.createElement("select");
			selectFontSize.mob = this;
			selectFontSize.setAttribute("unselectable", "on");
			selectFontSize.onchange = function() { this.mob.editorExec('fontsize', this); };
			var fontName = new Array(
				{ value: "Size", text: "Size" },
				{ value: "1", text: "1" },
				{ value: "2", text: "2" },
				{ value: "3", text: "3" },
				{ value: "4", text: "4" },
				{ value: "5", text: "5" },
				{ value: "6", text: "6" },
				{ value: "7", text: "7" }
			);
			for(var i = 0; i < fontName.length; i++)
			{
				var input = document.createElement("option");
				input.setAttribute("value", fontName[i].value);
				input.innerHTML = fontName[i].text;
				selectFontSize.appendChild(input);
			}
			this.toolbar.appendChild(selectFontSize);
	
			this.toolbar.appendChild(document.createElement("br"));
	
			var buttons = new Array(
				{ src: "icones/undo.gif", title: "Undo", exec: "undo" },
				{ src: "icones/redo.gif", title: "Redo", exec: "redo" },
				{ separator: true },
				{ src: "icones/bold.gif", title: "Bold", exec: "bold" },
				{ src: "icones/italic.gif", title: "Italic", exec: "italic" },
				{ src: "icones/underline.gif", title: "Underline", exec: "underline" },
				{ src: "icones/subscript.gif", title: "Subscript", exec: "subscript" },
				{ src: "icones/superscript.gif", title: "Superscript", exec: "superscript" },
				{ src: "icones/strikethrough.gif", title: "Strike through", exec: "strikethrough" },
				{ src: "icones/forecolor.gif", title: "Foreground color", exec: "forecolor" },
				{ src: "icones/backcolor.gif", title: "Background color", exec: "hilitecolor" },
				{ separator: true },
				{ src: "icones/left.gif", title: "Jutify left", exec: "justifyleft" },
				{ src: "icones/center.gif", title: "Center", exec: "justifycenter" },
				{ src: "icones/right.gif", title: "Jutify right", exec: "justifyright" },
				{ src: "icones/justify.gif", title: "Jutify", exec: "justifyfull" },
				{ src: "icones/uliste.gif", title: "Unordered list", exec: "insertunorderedlist" },
				{ src: "icones/oliste.gif", title: "Ordered list", exec: "insertorderedlist" },
				{ src: "icones/outdent.gif", title: "Outdent", exec: "outdent" },
				{ src: "icones/indent.gif", title: "Indent", exec: "indent" },
				{ separator: true },
				{ src: "icones/hr.gif", title: "Horizontal rule", exec: "inserthorizontalrule" },
				{ src: "icones/link.gif", title: "Insert link", exec: "createlink" },
				{ src: "icones/smartlink.gif", title: "(Insert smart link)", exec: "createsmartlink" },
				{ src: "icones/image.gif", title: "Insert image", exec: "insertimage" },
				{ src: "icones/table.gif", title: "Insert table", exec: "inserttable" }
			);
			var buttonsIE = new Array(
				{ src: "icones/copy.gif", title: "Copy", exec: "copy" },
				{ src: "icones/cut.gif", title: "Cut", exec: "cut" },
				{ src: "icones/paste.gif", title: "Paste", exec: "paste" },
				{ src: "icones/pastetext.gif", title: "Paste as text", exec: "pastetext" },
				{ separator: true }
			);
			if(this.isIE)
				buttons = buttonsIE.concat(buttons);
			for(var i = 0; i < buttons.length; i++)
			{
				var img = document.createElement("img");
				if(buttons[i].separator)
					img.setAttribute("src", this.basePath + "icones/separator.gif");
				else				
				{
					img.setAttribute("src", this.basePath + buttons[i].src);
					img.setAttribute("title", buttons[i].title);
					img.mob = this;
					img.mobExec = buttons[i].exec;
					img.onclick = function() { this.mob.editorExec(this.mobExec, this); };
					img.onmouseover = function() { this.mobOldBackgroundColor = this.style.backgroundColor; this.style.backgroundColor = "#8282ff"; };
					img.onmouseout = function() { this.style.backgroundColor = this.mobOldBackgroundColor; };
					img.style.cursor = "pointer";
					img.style._cursor = "hand";
				}
				this.toolbar.appendChild(img);
			}
	
			tableToolbarCell.appendChild(this.toolbar);
		}
	
		tableToolbarRow.appendChild(tableToolbarCell);
		tableBody.appendChild(tableToolbarRow);
	
		var tableEditorRow = document.createElement("tr");
		tableEditorRow.setAttribute("height", "100%");
		var tableEditorCell = document.createElement("td");
	
		this.editorWYSIWYG = document.createElement("iframe");
		this.editorWYSIWYG.setAttribute("frameborder", "no");
		this.editorWYSIWYG.style.width = "100%";
		this.editorWYSIWYG.style.height = "100%";
		tableEditorCell.appendChild(this.editorWYSIWYG);	

		//this.pasteFrame = document.createElement("iframe");
		//this.pasteFrame.setAttribute("frameborder", "no");
		//this.pasteFrame.style.width = "10%";
		//this.pasteFrame.style.height = "10%";
		//this.pasteFrame.style.display = "inline";
		//tableEditorCell.appendChild(this.pasteFrame);	
		
		this.editorHTML = document.createElement("textarea");
		this.editorHTML.style.display = "none";
		this.editorHTML.style.width = "100%";
		this.editorHTML.style.height = "100%";
		tableEditorCell.appendChild(this.editorHTML);
	
		tableEditorRow.appendChild(tableEditorCell);
		tableBody.appendChild(tableEditorRow);
	
		tableEditor.appendChild(tableBody);
		this.editorElement = tableEditor;
		if(this.editorPlace != null)
			this.editorPlace.appendChild(this.editorElement);
	
	
		// Create the color palette
		{
			this.colorPalette = document.createElement('div');
			this.colorPalette.style.display = "none";
			this.colorPalette.style.position = "absolute";
			this.colorPalette.style.backgroundColor = "White";
			var colors = new Array(
				'#ffffff', '#ffcccc', '#ffcc99', '#ffff99', '#ffffcc', '#99ff99', '#99ffff', '#ccffff', '#ccccff', '#ffccff',
				'#cccccc', '#ff6666', '#ff9966', '#ffff66', '#ffff33', '#66ff99', '#33ffff', '#66ffff', '#9999ff', '#ff99ff',
				'#c0c0c0', '#ff0000', '#ff9900', '#ffcc66', '#ffff00', '#33ff33', '#66cccc', '#33ccff', '#6666cc', '#cc66cc',
				'#999999', '#cc0000', '#ff6600', '#ffcc33', '#ffcc00', '#33cc00', '#00cccc', '#3366ff', '#6633ff', '#cc33cc',
				'#666666', '#990000', '#cc6600', '#cc9933', '#999900', '#009900', '#339999', '#3333ff', '#6600cc', '#993399',
				'#333333', '#660000', '#993300', '#996633', '#666600', '#006600', '#336666', '#000099', '#333399', '#663366',
				'#000000', '#330000', '#663300', '#663333', '#333300', '#003300', '#003333', '#000066', '#330099', '#330033'
			);
			var table = document.createElement("table");
			table.setAttribute("border", "1");
			table.setAttribute("cellpadding", "0");
			table.setAttribute("cellspacing", "0");
			var tbody = document.createElement("tbody");
			for(var k = 0, i = 0; i < 7; i++)
			{
				var tr = document.createElement("tr");
				for(var j = 0; j < 10; j++)
				{
					var td = document.createElement("td");
					var input = document.createElement("input");
					input.setAttribute("type", "button");
					input.style.background = colors[k];
					input.style.height = input.style.width = '20px';
					input.mob = this;
					input.mobColor = colors[k];
					input.onclick = function() { this.mob.selectColor(this.mobColor) };
					td.appendChild(input);
					tr.appendChild(td);
					k++;
				}
				tbody.appendChild(tr);
			}
			var tr = document.createElement("tr");
			var td = document.createElement("td");
			td.setAttribute("colspan", "10");
			td.colSpan = 10;
			var input = document.createElement("input");
			input.setAttribute("type", "button");
			input.setAttribute("value", "Cancel");
			input.style.width = '100%';
			input.mob = this;
			input.onclick = function() { this.mob.colorPalette.style.display = 'none'; };
			td.appendChild(input);
			tr.appendChild(td);
			tbody.appendChild(tr);
			table.appendChild(tbody);
			this.colorPalette.appendChild(table);
			body.appendChild(this.colorPalette);
		}

		if(this.editorPlace != null)
		{
			this.designedModeReadyCallback = function()
			{
				this.setEditorContent(initHtml);
			}
			this.enableDesignMode();
		}
	}
	else
	{
		this.editorHTML = document.createElement("textarea");
		this.editorHTML.style.display = "inline";
		this.editorHTML.style.width = "100%";
		this.editorHTML.style.height = "100%";

		this.editorElement = this.editorHTML;
		if(this.editorPlace != null)
			this.editorPlace.appendChild(this.editorElement);

		this.modeHTML = true;
		this.editorReady = true;
		
		if(initHtml)
			this.setEditorContent(initHtml);
	}
}

Mob.prototype.setBeginNewEditionCallback = function(beginNewEditionCallback)
{
	this.beginNewEditionCallback = beginNewEditionCallback;
}

Mob.prototype.beginNewEdition = function(beginNewEditionCallback)
{
	if(this.beginNewEditionCallback != null)
		if(!this.beginNewEditionCallback())
			return false;

	this.beginNewEditionCallback = beginNewEditionCallback;
	return true;
}

Mob.prototype.setDesignedModeReadyCallback = function(designedModeReadyCallback)
{
	this.designedModeReadyCallback = designedModeReadyCallback;
}

Mob.prototype.getEditorElement = function()
{
	return this.editorElement;
}

Mob.prototype.enableDesignMode = function()
{
	if(this.isMozilla || this.isIE)
	{
		this.editorReady = false;
		
		this.editorWindow = this.editorWYSIWYG.contentWindow;
		if(this.isMozilla)
		{
			var selfPage = this;
		
			setTimeout(function() {
					selfPage.editorDocument = selfPage.editorWYSIWYG.contentDocument;
					selfPage.editorDocument.designMode = "On";
					selfPage.editorWindow.focus();
					selfPage.editorReady = true;
					if(selfPage.designedModeReadyCallback != null)
						selfPage.designedModeReadyCallback();
				}, 300);
		}
		else
		{
			this.editorDocument = this.editorWindow.document;
			this.editorDocument.designMode = "On";
			this.editorWindow.focus();
			this.editorReady = true;
			if(this.designedModeReadyCallback != null)
				this.designedModeReadyCallback();
		}
	}
}

Mob.prototype.getEditorContent = function()
{
	if(this.modeHTML)
		return this.editorHTML.value;
	else
		return this.editorDocument.body.innerHTML;
}
Mob.prototype.setEditorContent = function(html)
{
	if(this.modeHTML)
	{
		this.editorHTML.value = html;	
	}
	else
	{
		var selfPage = this;
		this.tmpHtml = html;
		if(typeof(this.editorDocument) == "undefined" || this.editorDocument.body == null || !this.editorReady)
			setTimeout(function() { selfPage.setEditorContent(selfPage.tmpHtml) }, 100);
		else
			this.editorDocument.body.innerHTML = html;
	}
}

Mob.prototype.editorExec = function(action, element)
{
	// On IE http://msdn.microsoft.com/workshop/author/dhtml/reference/commandids.asp

	if(action == "forecolor" || action == "hilitecolor" || action == "backcolor") // ForeColor  BackColor
	{
		this.currentAction = action;
		this.colorPalette.style.left = getOffsetLeft(element); //element.style.left;
		this.colorPalette.style.top = getOffsetTop(element) + element.offsetHeight; //element.style.bottom;
		this.colorPalette.style.display = "inline";
		return;
	}
	else if(action == "formatblock" || action == "fontname" || action == "fontsize")
	{
		var currentSelection = element.selectedIndex;
		if(currentSelection != 0)
		{
			var selected = element.options[currentSelection].value;
			this.editorDocument.execCommand(action, false, selected);
			element.selectedIndex = 0;
		}
	}
	else if(action == "pastetext")
	{
		if(this.isMozilla)
		{
			this.editorDocument.execCommand("paste", false, null);

			//try { this.pasteFrame.contentDocument.execCommand("paste", false, null); }catch(e) {}
			//var pasteText = this.pasteFrame.contentDocument.body.ownerDocument.createRange();
			//pasteText.selectNodeContents(this.pasteFrame.contentDocument.body);
			//this.insertElement(document.createTextNode(pasteText.toString()));
		}
		else if(this.isIE)
	        this.insertElement(document.createTextNode(window.clipboardData.getData("Text")));
	}
	else if(action == "createlink")
	{
        var url = prompt('URL', 'http://');
        if(url != null)
	        this.editorDocument.execCommand(action, false, url);
	}
	else if(action == "createsmartlink")
	{
        var url = prompt('URL', 'http://');
        if(url != null)
        {
			var link = document.createElement("a");
			link.setAttribute("href", url);
			var url2 = url;
			if(url2.length > 60)
				url2 = url2.substr(0, 60) + "...";
			link.appendChild(document.createTextNode(url2));
			this.insertElements(new Array( document.createTextNode("("), link, document.createTextNode(")")));
		}
	}
	else if(action == "insertimage")
	{
        var url = prompt('Image: URL', 'http://');
        if(url != null)
	        this.editorDocument.execCommand('insertimage', false, url);
	}
	else if(action == "inserttable")
	{
		var table = document.createElement("table");
		table.setAttribute("border", "1");
		var tbody = document.createElement("tbody");
		for(var k = 0, i = 0; i < 2; i++)
		{
			var tr = document.createElement("tr");
			for(var j = 0; j < 2; j++)
			{
				var td = document.createElement("td");
				var text = document.createTextNode("" + i + "," + j);
				td.appendChild(text);
				tr.appendChild(td);
			}
			tbody.appendChild(tr);
		}
		table.appendChild(tbody);
		this.insertElement(table);
	}
	else
		this.editorDocument.execCommand(action, false, null);
	this.editorWindow.focus();
}

Mob.prototype.insertElement = function(el)
{
	this.insertElements(new Array(el));
}

Mob.prototype.insertElements = function(elements)
{
	if (this.isIE)
	{
		var selection = this.editorDocument.selection;
		var range = selection.createRange();
		for (var el in elements)
		{
			if(elements[el].outerHTML == null)
				range.pasteHTML(elements[el].data);
			else
				range.pasteHTML(elements[el].outerHTML);
		}
	}
	else
	{
		var selection = this.editorWindow.getSelection();
		var range = selection.getRangeAt(0);
		range.deleteContents(); 
		for (var i = elements.length - 1; i >= 0; i--)
			range.insertNode(elements[i]);
	}
}

Mob.prototype.selectColor = function(color)
{
	if(this.isIE && this.currentAction == "hilitecolor") this.currentAction = "backcolor";
	this.editorDocument.execCommand(this.currentAction, false, color);
	this.editorWindow.focus();
	this.colorPalette.style.display = "none";
}

Mob.prototype.viewSource = function(viewSource)
{
	if(viewSource)
	{
		this.editorHTML.value = this.editorDocument.body.innerHTML;
		this.editorHTML.style.display = "inline";
		this.editorWYSIWYG.style.display = "none";
		this.toolbar.style.display = "none";
		this.modeHTML = true;
		this.editorHTML.focus();
	}
	else
	{
		this.editorHTML.style.display = "none";
		this.editorWYSIWYG.style.display = "inline";
		this.editorDocument.body.innerHTML = this.editorHTML.value;
		this.toolbar.style.display = "inline";
		this.modeHTML = false;
		this.enableDesignMode();
	}
}

function getOffsetTop(elm)
{
    var mOffsetTop = elm.offsetTop;
    var mOffsetParent = elm.offsetParent;

    while(mOffsetParent)
    {
        mOffsetTop += mOffsetParent.offsetTop;
        mOffsetParent = mOffsetParent.offsetParent;
    }

    return mOffsetTop;
}

function getOffsetLeft(elm)
{
    var mOffsetLeft = elm.offsetLeft;
    var mOffsetParent = elm.offsetParent;

    while(mOffsetParent)
    {
        mOffsetLeft += mOffsetParent.offsetLeft;
        mOffsetParent = mOffsetParent.offsetParent;
    }

    return mOffsetLeft;
}
